'use strict';

exports.__esModule = true;
exports.inline = inline;

var _hash = require('./hash');

function extractNameFromProperty(str) {
  var regex = /name\s*:\s*([A-Za-z0-9\-_]+)\s*/gm;
  var match = regex.exec(str);
  if (match) {
    return match[1];
  }
}


function getName(extracted, identifierName, prefix) {
  var parts = [];
  parts.push(prefix);
  if (extracted) {
    parts.push(extracted);
  } else if (identifierName) {
    parts.push(identifierName);
  }
  return parts.join('-');
}

function createRawStringFromQuasi(strs) {
  var dynamicValueCount = 0;
  var src = strs.reduce(function (arr, str, i) {
    arr.push(str);
    if (i !== strs.length - 1) {
      dynamicValueCount++;
      arr.push('xxx' + i + 'xxx');
    }
    return arr;
  }, []).join('').trim();
  return { src: src, dynamicValueCount: dynamicValueCount };
}

function inline(quasi, identifierName, prefix) {
  var strs = quasi.quasis.map(function (x) {
    return x.value.cooked;
  });
  var hash = (0, _hash.hashArray)([].concat(strs));
  var name = getName(extractNameFromProperty(strs.join('xxx')), identifierName, prefix);

  var _createRawStringFromQ = createRawStringFromQuasi(strs),
      src = _createRawStringFromQ.src;

  return {
    name: name,
    hash: hash,
    src: src
  };
}